/*
 * Shedul.c
 *
 *  Created on: 05.05.2020
 *      Author: Sandra
 */

#include "Shedul.h"
#include <stdlib.h>
#include <stdio.h>


int read_prozess_simulation(SLIST_HEADER *ready, char * Prozesse ) {
   FILE *fp;
   int  anz=0;
   char b[LEN];

   fp=fopen(Prozesse, "r");
   if (fp==NULL) {
      perror("Kein File\n"); return -1;
   }

   fgets(b,LEN,fp);              // Ueberschrift verwerfen
   while ( fgets(b,LEN,fp) ) {
      PCB *pcb=calloc(sizeof(PCB),1);
      if ( pcb==NULL ) { perror("Kein Speicher\n"); return -2; }
      char *pstr;
      pstr=strtok(b,":");
      if(pstr==NULL) { perror("Formatfehler \n"); return -3; }
      pcb->pid=atoi(pstr);
      pstr=strtok(NULL,":");
      if(pstr==NULL) { perror("Formatfehler \n"); return -3; }
      pcb->startzeit=atoi(pstr);
      pstr=strtok(NULL,":");
      if(pstr==NULL) { perror("Formatfehler \n"); return -3; }
      pcb->laufzeit=atoi(pstr);

      put(ready, pcb );   // Liste einfuegen.
      anz++;
   }

   fclose(fp);
   return anz;
}


int scheduler_non_preemptiv_fcfs(SLIST_HEADER *ready, SLIST_HEADER *finished ) {
   int tick=0;
   PCB   *p=NULL;

   if (ready==NULL || finished==NULL) return 0;
   if (ready->Len==0) return 0;
   p=get(ready);
     while(1) {
     tick++;
     p->laufzeit++;

     if(tick==p->laufzeit){
    	 p=put(finished);
    	 p=get(ready);
    	 tick=0;

      printf("%4d P%d (%d von %d)\n",tick,p->pid,p->startzeit,p->laufzeit );
     }

     }

   }

