/*
 * fifo.c
 *
 *  Created on: 18.05.2020
 *      Author: Sandra
 */

#include <stdlib.h>
#include "fifo.h"
#include "List.h"

SLIST_HEADER * create_fifo()
{
	SLIST_HEADER *tmp = createSList();
	return tmp;
}
SLIST * put(SLIST_HEADER *head, void *data)
{
	if(head==NULL)
	{
		return NULL;
	}
	if(data == NULL)
	{
		return NULL;
	}
	return insertLast(head, data);
}

void * get(SLIST_HEADER *head)
{
	return deleteFirst(head);
}

int length(SLIST_HEADER *head)
{
	if(head == NULL)
	{
		return -1;
	}
	return head->Len;
}
